#include <Wire.h>
#include <ST7032.h>

//int analogPin = 0; 
double val1[8];           // 読み取った値を格納する変数
double sum[8],ave1[8],ave2[8];
double g;
long time,time0=0;
long i = 0;
int offset[8];
String str1,str2;
ST7032 lcd;
byte armsDown[8] = {
  0b00100,
  0b01010,
  0b00100,
  0b00100,
  0b01110,
  0b10101,
  0b00100,
  0b01010
};

byte armsUp[8] = {
  0b00100,
  0b01010,
  0b00100,
  0b10101,
  0b01110,
  0b00100,
  0b00100,
  0b01010
};

void setup() {
  Serial.begin(115200);        // シリアル通信の初期化
  analogReference(INTERNAL);    //参照電圧を1.1Vにして感度拡大
  offset[0]=0;
  offset[1]=0;
  offset[2]=0;
  offset[3]=0;
  
  lcd.begin(16, 2);
  lcd.setContrast(10);
  lcd.createChar(0, armsDown);  
  lcd.createChar(1, armsUp);  
}

void loop() {
  time=millis();
  i++;
  
  for(int j=0; j<4; j++){
  //アナログ値から皮膚温を計算
    val1[j] = analogRead(j);    // アナログピンを読み取る
    sum[j]+=val1[j];
  }
  
  //100msでデータを送信
  if(time >= time0 + 1000){
    
    //送信する文字列を生成
    str1="";str2="";
    for(int j=0; j<4; j++){
      //平均を算出し文字列へ連結
      ave1[j]=sum[j]/i;
      g=(double)1.1/(double)5.0;  //1.1Vリファレンス用のゲイン
      ave2[j]= (double)500/(double)1024 * ave1[j]*g;
      //str1+=(int)(ave2[j]*100);str1+=",";
      str1+=(int)(ave2[j]*100-offset[j]);str1+=",";
      str2+=(int)((ave2[j]*100-offset[j])/10);str2+=" ";
    }
    str1+=(long)i;
    
    //Serial.print(ave);  Serial.print(",");
    Serial.println(str1);
    
    //初期化
    for(int j=0; j<4; j++){    
      sum[j]=0;
    }
    time0 = time;
    i=0;    
    //delay(0);
  }
  
  lcd.setCursor(0, 0);
  lcd.print("Time:");
  lcd.print(millis()/1000);
  lcd.setCursor(0, 1);
  lcd.print(str2);
  lcd.setCursor(15, 0);
  
  if((time/1000)%30==0){lcd.write(1);}
  else{lcd.write(0);}
}

